
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>缓存设计学习笔记 / iVAN</title>

    <meta name="description" content="缓存设计学习笔记 背景 最近在&lt; redis 开发与运维&gt;这是在看11章时候记得笔记 存在和合理性 缓存到处都是啊 先放个最简单的图, 这里面每一层都可以有缓存 client 缓存 最常见的浏览器的http缓存. 还有app一般也加缓存,比如陌陌,这么大活跃的情况下,不缓存服务端鸭梨太大,&quot;更多帧&quot;的菜单就是客户端缓存了的,每15分钟才会去刷新一次 web server 最常见的nginx 对不常更新的静态资源可以在location 段里配expire来设置缓存时间: 还有ngin ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">缓存设计学习笔记</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>背景</h2>
<p>最近在《 redis 开发与运维》这是在看11章时候记得笔记</p>
<h2>存在和合理性</h2>
<h3>缓存到处都是啊</h3>
<p>先放个最简单的图， 这里面每一层都可以有缓存<br /><a href="https://yqfile.alicdn.com/05cac7a26698ce0c18be39be6d41f4a21d4c5194.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzA1Y2FjN2EyNjY5OGNlMGMxOGJlMzliZTZkNDFmNGEyMWQ0YzUxOTQucG5n.jpg"></a></p>
<h3>client 缓存</h3>
<ul>
<li>最常见的浏览器的http缓存。</li>
<li>还有app一般也加缓存，比如陌陌，这么大活跃的情况下，不缓存服务端鸭梨太大，“更多帧”的菜单就是客户端缓存了的，每15分钟才会去刷新一次</li>
</ul>
<h3>web server</h3>
<ul>
<li>最常见的nginx 对不常更新的静态资源可以在location 段里配expire来设置缓存时间； 还有nginx作为反向代理使用，可以做proxy cache</li>
<li>CDN 主要作用也是缓存，将资源缓存到里用户最近的物理机上，可以设置更新频率</li>
</ul>
<h3>业务层和DB</h3>
<ul>
<li>业务逻辑处理进程内的缓存   php-fpm 有yac，java也有很多进程内缓存的库</li>
<li>Redis  memcache</li>
</ul>
<p>总之，请求的任何一个环节都可以根据需要做缓存</p>
<h2>缓存收益</h2>
<ul>
<li>加快读写速度 基于内存（redis，memcache，yac），减少数据库（磁盘）io， 内存跟磁盘的读写速度不是一个等级的哈</li>
<li>降低后端负载 减少对后端数据的访问</li>
</ul>
<h2>成本</h2>
<ul>
<li>数据的不一致性：缓存层和存储层的数据存在一定时间窗口的不一致性，时间窗口取决于更新策略</li>
<li>代码维护成本：需要处理缓存层和存储层的逻辑</li>
<li>运维成本： 加了一层cache，比如说redis，运维肯定是有成本的</li>
</ul>
<h2>使用场景</h2>
<ul>
<li>开销大的复杂计算   如果不加缓存，每次都实时计算，无法满足高并发量</li>
<li>加速请求响应  这个就是为了更快，内存的io比磁盘的io快</li>
</ul>
<h2>Redis 为例讲下这种缓存的设计</h2>
<h3>更新策略</h3>
<h5>剔除算法 （LRU/LFU/FIFO)</h5>
<ul>
<li>使用方式 ： 配置 maxmemory 和 maxmemory-policy， 对总内存进行限制，达到后按算法进行剔除</li>
<li>场景 ：这个通常是从运维角度考虑， 避免没有限制直接影响整个机器的性能； 业务层面来说肯定不能依赖这种更新策略</li>
<li>维护成本 ：开发人员只需要选择合适的算法就行，不用自己对数据进行更新</li>
<li>一致性  ：很差，你无法决定数据什么时候会过期，完全看redis本身的算法实现和触发机制</li>
</ul>
<h5>超时剔除</h5>
<ul>
<li>使用方式  对key 设置过期时间</li>
<li>场景  最常用的，只要是对一致性（实时）要求不高的都可以用，可以加快处理速度哦</li>
<li>维护成本 ：不高  用expire 设置过期时间即可，前提是允许缓存数据和真实数据在过期时间内存在不一致</li>
<li>一致性  一段时间窗口内（就是设置的过期时间）存在不一致问题</li>
</ul>
<h5>主动更新</h5>
<ul>
<li>使用场景 ： 一致性要求高的地方，真实数据更新后，立刻要求缓存也更新</li>
<li>一致性： 高； 注意的地方是主动更新万一失败，旧数据可能会很久不被更新</li>
<li>维护成本： 高  主要开发主动更新的逻辑，并且保证更新的正确性</li>
</ul>
<h3>粒度控制</h3>
<p>这个实际上就是缓存内容的选择问题，假设mongo里有一条完整的记录，我们是选择<code>全部数据</code>都缓存还是选择其中的<code>部分数据</code>缓存起来的问题<br />
我们从3个角度来分析下</p>
<h5>通用性</h5>
<p>全部数据肯定比部分数据更通用，但很多业务场景只需要部分数据</p>
<h5>空间占用：</h5>
<p>全部数据显然占用更多的空间，成本更高</p>
<ul>
<li>内存还是比较昂贵的，全缓存起来可能会浪费</li>
<li>全部数据本身如果比较大的话，在高吞吐量的情况下，对网络带宽影响也比较大，极端情况会阻塞网络</li>
<li>大的数据结构序列号和反序列化也耗时啊</li>
</ul>
<h5>代码维护</h5>
<p>全部数据就不用讲了。。。部分数据开发成本就比较多了</p>
<h5>结合实践来分析下</h5>
<p>就拿我们平台的<code>应用信息</code> 来说，数据非常多，基本配置几十个字段，区分ios和android的配置也各有20来个字段，</p>
<ul>
<li>当前是全部字段 json序列化后都存redis里呢</li>
<li>实际业务开发中，你会经常发现我就为了拿1-2个字段，但是得整个读出来然后还json_decode ... 觉得好蛋疼</li>
<li>如果redis真的是缓存层，应用信息这个单节点的redis早就挂了</li>
<li>还好，我们的redis 基本是当存储层在用了；完整的应用信息都会有进程内缓存(php yac，java那边也加了)起来</li>
<li>所以实际用时的经验来说，我觉得这种还是<code>根据业务分门别类拆成多个key来存比较好，出了问题迁移和隔离方便，虽然开发成本高了点</code></li>
</ul>
<h3>缓存穿透</h3>
<p>概念：不存在的数据每次请求都会去到存储层查询，并且对该数据并发请求量很大，就会对后端系统造成很大的压力，失去了缓存保护后端存储的意义。这就叫做缓存穿透</p>
<h5>过程如下</h5>
<ul>
<li>缓存层不命中</li>
<li>存储层不命中，不将空结果填入缓存</li>
<li>返回空结果</li>
<li><code>如果出现了大量存储层的空命中，很可能就是出现了缓存穿透问题</code></li>
</ul>
<h5>原因分析</h5>
<ul>
<li>自身的业务代码逻辑有问题，或者数据出了问题</li>
<li>恶意攻击、爬虫等造成大量空命中</li>
</ul>
<h5>办法1  缓存空对象</h5>
<ul>
<li>空值也缓存起来，就可以保护存储层了</li>
<li>空值缓存起来，会浪费更多内存；如果是攻击，那就更惨了。通常的办法是设个比较短的过期时间，让他自动过期</li>
<li>加了过期又需要考虑 数据不一致的问题，如果在意，还需要开发-数据有了后清除空值的逻辑</li>
</ul>
<h5>办法2  拦截</h5>
<ul>
<li>把存在的key存起来，加一层拦截</li>
<li>常用的比如<code>布隆过滤器</code>  我们陌陌客户端在用户资料帧的”已玩过的游戏“就用了这个拦截掉大部分请求（1.8亿/2.5亿）</li>
</ul>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:00:06</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8/" title="存储">存储</a>, <a href="https://www.iamivan.net/tag/%e7%a3%81%e7%9b%98/" title="磁盘">磁盘</a>, <a href="https://www.iamivan.net/tag/%e7%ae%97%e6%b3%95/" title="算法">算法</a>, <a href="https://www.iamivan.net/tag/cache/" title="Cache">Cache</a>, <a href="https://www.iamivan.net/tag/redis/" title="redis">redis</a>, <a href="https://www.iamivan.net/tag/%e9%ab%98%e5%b9%b6%e5%8f%91/" title="高并发">高并发</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>缓存设计学习笔记的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1kDLaz.html" rel="bookmark">&period;net中Petshop4&period;0 缓存设计学习教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Asp.net 2.0新增的缓存管理:  CacheDependency跟踪缓存依赖项,缓存依赖项可以是应用程序的 Cache 中的文件.目录或与其他对象的键.   SqlCacheDependency类在所有受支持的 SQL Server 版本 (7.0, 2000, 2005) 上监视特定的 SQL Server 数据库表,以便在该表发生更改时,自动从 Cache 中删除与该表关联的项. 数据库表发生更改时,将自动删除缓存项,并向 Cache 中添加新版本的项.在使用 SQL Server			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1NXL3p.html" rel="bookmark">NSURLRequest缓存策略学习笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#define kGetURL @&quot;http://api.map.baidu.com/place/v2/search?query=银行&amp;region=上海&amp;output=json&amp;ak=6E823f587c95f0148c19993539b99295″ #define kPostURL @&quot;http://ipad-bjwb.bjd.com.cn/DigitalPublication/publish/Handler/APINewsList.ashx&quot; #			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB2lG4b.html" rel="bookmark">hibernate3&period;0学习笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				hibernate3学习笔记(二十三)|进阶特性(三) hibernate3学习笔记(二十三)|进阶特性(二) hibernate3学习笔记(二十三)|进阶特性(一) hibernate3学习笔记(二十二)|Query缓存机制 hibernate3学习笔记(二十一)|二级缓存 hibernate3学习笔记(二十)|关系映射:多对多 hibernate3学习笔记(十九)|关系映射:一对一 hibernate3学习笔记(十八)|关系映射:一对多 hibernate3学习笔记(十七)|关系映射:多对一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlKQBnb.html" rel="bookmark">JavaScript权威设计--JavaScript函数&lpar;简要学习笔记十一&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.函数调用的四种方式 第三种:构造函数调用 如果构造函数调用在圆括号内包含一组实参列表,先计算这些实参表达式,然后传入函数内.这和函数调用和方法调用是一致的.但如果构造函数没有形参,JavaScript构造函数调用的语法是允许省略实参列表和圆括号的. 如: var o=new Object(); //-&gt;等价于 var o=new Object;   第四种:使用call()与apply()间接调用(放在后面详细说明)   2.函数的实参与形参--可选形参 先看一个例子: function g			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXq2dWz.html" rel="bookmark">thinkphp学习笔记5&mdash;模块化设计</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:thinkphp学习笔记5-模块化设计 1.模块结构 完整的ThinkPHP用用围绕模块/控制器/操作设计,并支持多个入口文件盒多级控制.ThinkPHP默认PATHINFO模式,如下: http://serverName/index.php(或者其他应用入口文件)/模块/控制器/操作/[参数名/参数值...] 应用:由同一个入口文件访问的项目称为一个应用,在完整版的代码中就是Application 模块:一个应用下面可以包含多个模块,每个模块对应独立的目录,在完整版的代码中有Admin,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB1oo4z.html" rel="bookmark">JavaScript权威设计--JavaScript函数&lpar;简要学习笔记十&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.函数命名规范 函数命名通常以动词为前缀的词组.通常第一个字符小写.当包含多个单词时,一种约定是将单词以下划线分割,就像&quot;like_Zqz()&quot;. 还有一种就是&quot;likeZqz()&quot;.有些些函数是用作内部用的或者为私有函数通常以一条下划线为前缀,就像&quot;_zqzName()&quot;.   2.以表达式方式定义的函数 如: var zqz=function (){ return &quot;zhaoqize&quot;; } 在使用的时候必须把它赋值给一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAkj72z.html" rel="bookmark">学习笔记之JAVA图形设计卷I AWT&mdash;&mdash;第3章 图 形</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				   学习笔记之JAVA图形设计卷I AWT--第3章 图 形 前时显示器坏了,file://写前言:我觉得写的不是学习笔记,倒象教程.我是想让有所获,故详细了点.注意1:在AWT中提供的用户接口构件(如按钮.列表.菜单.对话框等)不包含一些类似的纯粹的绘制图形的对象(如Line或Circle类) 详细意思:由于原始的AWT在设计时不允许纯粹的绘制图形的对象,那么Rectangle.Polygon和Point没有任何绘制图形的能力.换句话说,Rectangle.Polygon和Point不具备d			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr3nW4p.html" rel="bookmark">作为一个新手的Oracle（DBA）学习笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<a href="https://www.iamivan.net/a/Mr3nW4p.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MTAxMDIwMjU1NTA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y1hGZk1qUTVPVFEzTnpjPS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg">
							</a>
						<div class="summary">
				Oracle数据库笔记 Jack Chaing 作者QQ595696297 交流群 127591054 祝大家学习进步. 如果大家想看Word版本的可以去下载:Word排版比较清晰一些. http://download.csdn.net/detail/jack__chiang/9810532 此笔记是作者本人去年开始从一个DBA新人的学习笔记,积累至今,希望拿出来给那些对DBA有兴趣的童孩学习,大家一起努力嘛. 此笔记记录了作者工作学习中从零基础的学习的记录,和从中遇见的问题与问题的解决!很高兴			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwGZwp.html" rel="bookmark">VSTO学习笔记（二）Excel对象模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:VSTO学习笔记(二)Excel对象模型 上一次主要学习了VSTO的发展历史及其历代版本的新特性,概述了VSTO对开发人员的帮助和效率提升.从这次开始,将从VSTO 4.0开始,逐一探讨VSTO开发中方方面面,本人接触VSTO时间不长,也是一次尝试.鉴于Excel在整个Office家族中的重要地位,故先从Excel开始介绍,后续内容会陆续介绍Word.PowerPoint.Outlook.InfoPath等.由于VSTO 4.0建立在Office 2010基础之上,先介绍一下Office			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbK7RLb.html" rel="bookmark" class="title">⑨云上场景：趣拍，短视频一站式解决方案</a>
					<div>
						趣拍SDK的梦想是将视频能力开放,让更多开发者使用这个功能.从诞生日起,在没有任何市场推广的情况下,趣拍SDK的讨论群从无到有,瞬间聚集了数百开发者,吸引数百应用接入,覆盖过亿用户.   早期,趣拍就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrKNWp.html" rel="bookmark" class="title">Linux多线程之同步</a>
					<div>
						引言 条件变量是利用线程间共享的全局变量进行同步的一种机制,主要包括两个动作:一个线程等待条件变量的条件成立而挂起(此时不再占用cpu):另一个线程使条件成立(给出条件成立信号).为了防止竞争,条件变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpklROz.html" rel="bookmark" class="title">如何寻求另类方法解决网站排名不稳定的现象</a>
					<div>
						  大多数站长肯定都经历过网站一波三折的经历,今天也许网站的排名还在后几页,明天就进入了百度首页,而在等几天网站排名突然有丧失,这些经历让很多站长感受到做网站的无奈,其实对于一名站长朋友来说网站优化出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnqXOM.html" rel="bookmark" class="title">简单计数器的实现</a>
					<div>
						计数器 本教程属于原载,转载请注明出自网页教学网 说明: 实现原理是:利用PHP的功能函数去读取文本文件的数据,从而实现数据的统计. 1. 新建一个文件取名为:counter.php.代码如下: &l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqwo3z.html" rel="bookmark" class="title">SEO优化也要适可而止 否则将适得其反</a>
					<div>
						对于每一个站长而言每天必不可少的除了网站日常更新之外,还有就是持续做着网站内外优化部分的工作.我们也都知道,如果我们想要一个网站权重最大化的情况下,必然我们要在SEO优化上面下足功夫,让我们的站点在同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1GD9z.html" rel="bookmark" class="title">如何用java程序把本地文件拷贝到hdfs上并显示进度</a>
					<div>
						把程序打成jar包放到Linux上 转到目录下执行命令 hadoop jar mapreducer.jar /home/clq/export/java/count.jar  hdfs://ubuntu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2J3jM.html" rel="bookmark" class="title">Struts2中的单Form多图片提交按钮&lpar;Submit&rpar;的使用</a>
					<div>
						在Struts2里面一个Form中如果有多个提交按钮,比如添加,更新,保存等, 这些按钮使用一个Action,调用不同的方法,并且在调用前要执行一个JavaScript的检查. 怎么用这个提交按钮?  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7ZdWM.html" rel="bookmark" class="title">如何在指定矩形中旋转显示文字</a>
					<div>
						/////////////////////////////////////////////////////// //说明: // 在矩形框中旋转方式显示文字,jingzhou xu //参数: //  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxBOrb.html" rel="bookmark" class="title">筛选Excel 2007单元格区域或表中的数据</a>
					<div>
						Excel2007使用自动筛选来筛选数据,可以快速而又方便地查找和使用单元格区域或表列中数据的子集. 了解有关筛选的详细信息 筛选过的数据仅显示那些满足指定条件 (条件:所指定的限制查询或筛选的结果集 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElX1qz.html" rel="bookmark" class="title">ppt2010版运用形状编辑顶点功能设计出圆弧效果图文教程</a>
					<div>
						  首先,在ppt中插入一个矩形,即在插入选项卡中选择形状矩形,并画出 点击右键设置形状格式,选择自己想要的效果,这里我选择了纯色填充,无线条颜色 产生的效果如图 双击图形,菜单栏插入形状有一个编辑形 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqL60Rb.html" rel="bookmark" class="title">PowerPoint 2007 页眉和页脚文本被打印出来</a>
					<div>
						  在PowerPoint 2007 中以讲义形式打印演示文稿时,演示文稿的页眉和页脚文本可能会意外地打印出来.或者,如果在打印预览中查看演示文稿,页眉和页脚文本可能会显示出来.即使您未在&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwvaqp.html" rel="bookmark" class="title">windows 2003修改远程桌面连接数</a>
					<div>
						  Windows Server 2003默认情况下允许远程终端连接的数量是2个用户,我们可以根据需要适当增加远程连接同时在线的用户数. 单击&quot;开始→运行&quot;,输入&quot;gpe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNGEGM.html" rel="bookmark" class="title">java之HeapByteBuffer&amp;amp&semi;amp&semi;DirectByteBuffer以及回收DirectByteBuffer</a>
					<div>
						byte buffer一般在网络交互过程中java使用得比较多,尤其是以NIO的框架中: 看名字就知道是以字节码作为缓冲的,先buffer一段,然后flush到终端. 而本文要说的一个重点就是Heap ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Ee8aM.html" rel="bookmark" class="title">桌面开发者的界面故事，该醒醒了</a>
					<div>
						     本文我们只谈界面.             大部分人最开始学习编程是Console,搞个计算器啥的,后来高级一点能做一个俄罗斯方块出来.很羡慕那些能做出界面的,于是大二学了MFC,一开始看& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7ojPp.html" rel="bookmark" class="title">酒店幽灵五年盗窃全美，竟师从黑客？</a>
					<div>
						酒店,不少浪漫爱情的发生之地. 但离奇古怪的事情也不少见. 最近雷锋网从微信公众号英国那些事上听来个故事,故事发生在五年前美国的菲尼克斯,又译凤凰城. 这座在Navajo语中被称为Hoozdo的炎热之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBxw8b.html" rel="bookmark" class="title">ios开发-小白跪求解决方案，objective c 一个出错问题，具体看问题补充</a>
					<div>
						问题描述 小白跪求解决方案,objective c 一个出错问题,具体看问题补充 照着书模拟了个小软件,屏幕上两个按钮,一个edit 一个new 点击new可以创建新的便签,点击edit可以删除便签, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba71kXp.html" rel="bookmark" class="title">iOS7开发学习之路&colon;No&period;10：XCode手动Clean资源文件，xib文件autolayout，对某个特定文件关闭ARC</a>
					<div>
						最近两周疯狂地加班赶项目,很多积累的问题都没有及时做总结,今天把上两周中出现的问题做个总结吧: 1. Xcode必须手动Clean项目资源文件 之前是因为项目需要,有一些资源文件更换了,比如图片什么的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/MlKlvOb.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vZXNzYXkuYjAudXBhaXl1bi5jb20vMTc0Ny8zNjc0ODcvMC5qcGc=.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/MlKlvOb.html" rel="bookmark" class="title">分享7家典型大数据公司</a>
					<div>
						          Skybox.Prismatic.SAGA.Zest Finance.Expect Labs.Decide.Trifacta这7家公司告诉了我们:大数据绝不仅仅是互联网. [1]  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEDVnM.html" rel="bookmark" class="title">比iPhone&comma;6还火爆：阿里路演排队者拐了18个弯</a>
					<div>
						据美国CNBC报道,在阿里巴巴美国路演首日,有超过1000位投资者赶赴华尔道夫酒店参加路演午餐会.因为人数实在太多,现场排的队伍拐了18个弯,光是等电梯就需要30分钟,这一盛况远远超过苹果旗舰店门口等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8APYBz.html" rel="bookmark" class="title">java中如何理解switch语句参数的对象&period;what</a>
					<div>
						问题描述 java中如何理解switch语句参数的对象.what java中如何理解switch语句参数的对象.what switch (msg.what) { ......} 解决方案 msg是一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyerAlM.html" rel="bookmark" class="title">在北京，商业企业如何申请增值税一般纳税人资格？</a>
					<div>
						问题描述 注册地址.经营场所及库房的租赁合同10.注册地址.经营场所房屋产权证明11.注册地址.经营场所及库房近期支付房租的发票12.货物购.销合同或书面意向13.企业为从业人员出资上社会保险的证明( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkA71wb.html" rel="bookmark" class="title">牢记25个最佳的SSH命令</a>
					<div>
						OpenSSH是SSH连接工具的免费版本.telnet,rlogin和ftp用户可能还没意识到他们在互联网上传输的密码是未加密的,但SSH是加密的,OpenSSH加密所有通信(包括密码),有效消除了窃 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRmLKp.html" rel="bookmark" class="title">Yii学习笔记--简单的使用</a>
					<div>
						一．搭建步骤   1.下载 2.把文件解压,放到根目录  Php yii/framework/yiic.php webapp demo 创建了一个应用,因为项目需要framework的文件,所以不要删 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60oOAz.html" rel="bookmark" class="title">linux进程的基本概念</a>
					<div>
						学习操作系统已经有两年了,惭愧的是至今没有好好复习一下课本上关于进程这一章节的内容,以至于到现在很多概念性的东西,很多深层次的东西理解起来总是不通顺,所以我决定花自己一个下午的时间,好好把这一章节整理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnXG8M.html" rel="bookmark" class="title">&amp;amp&semi;amp&semi;&num;9733&semi;36句经典英文格言</a>
					<div>
						1.Practice makes perfect.熟能生巧. 2.God helps those who help themselves.天助自助者. 3.Easier said than done. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZqw3p.html" rel="bookmark" class="title">asp&period;net常用函数收藏第1&sol;2页</a>
					<div>
						/// &lt;summary&gt; /// 得到站点用户IP /// &lt;/summary&gt; /// &lt;returns&gt;&lt;/returns&gt; public sta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4445Nz.html" rel="bookmark" class="title">Vue&period;js基础知识汇总&lowbar;其它</a>
					<div>
						介绍 vue.js 是用来构建web应用接口的一个库 技术上,Vue.js 重点集中在MVVM模式的ViewModel层,它连接视图和数据绑定模型通过两种方式.实际的DOM操作和输出格式被抽象的方式到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8oX5p.html" rel="bookmark" class="title">Android开发之ListView优化方案</a>
					<div>
						我们使用ViewHolder时,把每一个item的子View控件对象都放在ViewHolder中,当第一次创建convertView对象时,便把这些item的子View控件对象findViewById ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Nd6jz.html" rel="bookmark" class="title">GWT中复制到剪贴板 js&plus;flash实现复制 兼容性比较好&lowbar;javascript技巧</a>
					<div>
						但是用flash就可以复制.例子就是VeryCd,看&quot;复制选中的连接&quot;按钮是一个flash.看来flash的安全沙箱没有限制将内容复制到剪贴板      但是也是有限制的:  1  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKODlM.html" rel="bookmark" class="title">linux下练习 c&plus;&plus; 容器的deque的特性</a>
					<div>
						/* deque特性 下标:.operator[](i)不检查越界,.at(i) 删除:.pop_front(),.pop_back() */ #include&lt;iostream&gt; usi ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
